#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QPushButton>
#include <QLabel>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLineEdit>
#include <QMessageBox>
#include <QComboBox>
#include <QTextEdit>
#include "queue.h"

class MainWindow : public QMainWindow {
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private slots:
    void onAddButtonClicked();
    void onDeleteButtonClicked();
    void onGetMaxButtonClicked();
    void onGetMinButtonClicked();
    void onClearButtonClicked();
    void onAddQueueButtonClicked();
    void onQueueSelectionChanged(int index);
    void onAddQueuesButtonClicked();
    void onSubtractQueuesButtonClicked();
    void onOverflowMemoryButtonClicked();
    void onDisplayQueueButtonClicked();

private:
    QWidget *centralWidget;
    QVBoxLayout *mainLayout;
    QHBoxLayout *buttonLayout;
    QHBoxLayout *queueSelectionLayout;
    QHBoxLayout *operationLayout;
    QPushButton *addButton;
    QPushButton *deleteButton;
    QPushButton *getMaxButton;
    QPushButton *getMinButton;
    QPushButton *clearButton;
    QPushButton *addQueueButton;
    QPushButton *addQueuesButton;
    QPushButton *subtractQueuesButton;
    QPushButton *overflowMemoryButton;
    QPushButton *displayQueueButton;
    QLabel *queueDisplay;
    QComboBox *queueSelector;
    QLineEdit *inputSequence;
    QTextEdit *queueOutput;

    std::vector<CQueue> queues;
    int currentQueueIndex;

    void updateQueueDisplay();
    void displayError(const std::exception& e);
};

#endif // MAINWINDOW_H
